<?php
/*-----8<--------------------------------------------------------------------
 * 
 * BEdita - a semantic content management framework
 * 
 * Copyright 2008 ChannelWeb Srl, Chialab Srl
 * 
 * This file is part of BEdita: you can redistribute it and/or modify
 * it under the terms of the Affero GNU General Public License as published 
 * by the Free Software Foundation, either version 3 of the License, or 
 * (at your option) any later version.
 * BEdita is distributed WITHOUT ANY WARRANTY; without even the implied 
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the Affero GNU General Public License for more details.
 * You should have received a copy of the Affero GNU General Public License 
 * version 3 along with BEdita (see LICENSE.AGPL).
 * If not, see <http://gnu.org/licenses/agpl-3.0.html>.
 * 
 *------------------------------------------------------------------->8-----
 */

/**
 * 
 *
 * @version			$Revision: 2325 $
 * @modifiedby 		$LastChangedBy: dante $
 * @lastmodified	$LastChangedDate: 2009-10-02 17:53:52 +0200 (ven, 02 ott 2009) $
 * 
 * $Id: media_provider.php 2325 2009-10-02 15:53:52Z dante $
 */
class MediaProviderHelper extends AppHelper {
	
	var $helpers = array('Html','Youtube','Blip','Vimeo','BeEmbedFlash');
	
	var $conf = null ;

	function __construct() {
		$this->conf 	= Configure::getInstance() ;
	}
	
	/**
	 * get img tag for thumbnail
	 */
	function thumbnail(&$obj, $htmlAttributes = array(), $URLonly=false ) {
		if (!empty($obj["thumbnail"]) && preg_match(Configure::read("validate_resource.URL"), $obj["thumbnail"]))
			return (!$URLonly)? $this->Html->image($obj["thumbnail"], $htmlAttributes) : $obj["thumbnail"];
		
		if (!$helperName = $this->getHelperName($obj))
			return "";
		
		return $this->{$helperName}->thumbnail($obj, $htmlAttributes, $URLonly);
	}
	
	/**
	 * get embed video
	 */
	function embed(&$obj, $params = array(), $attributes = array() ) {
		
		// provider helper to manage video/audio type don't exists
		if (!$helperName = $this->getHelperName($obj)){
			$obj['path'] = ($this->checkURL($obj['path'])) ? $obj['path'] : Configure::read('mediaUrl').$obj['path'];
			return  $this->BeEmbedFlash->embed($obj, $params, $attributes);
		}
		
		// provider helper exists and it's setted to use provider helper 
		if (!empty($params['useProviderPlayer'])) {
			return $this->{$helperName}->embed($obj, $attributes);
		} else {
			// try to use internal player
			$obj['path'] = $this->sourceEmbed($obj);
			$res = $this->BeEmbedFlash->embed($obj, $params, $attributes);
			if ( $res === false ) {
				$res =  $this->{$helperName}->embed($obj, $attributes) ;
			}
			return $res;
		}
	}
	
	/**
	 * get source url
	 */
	function sourceEmbed(&$obj) {
		if (!$helperName = $this->getHelperName($obj))
			return "";
			
		return $this->{$helperName}->sourceEmbed($obj);
	}
	
	private function getHelperName(&$obj) {
		if(empty($obj['provider'])) 
			return false ;
		$helperName = Inflector::camelize($obj['provider']);
		if (!isset($this->{$helperName})) {
			return false;
		}
		return $helperName;
	}
	
	private function checkURL($url) {
		foreach (Configure::read('validate_resource.allow') as $reg) {
			if(preg_match($reg, $url)) 
				return true;
		}
		return false;
	}
	
}

?>